extern crate libusb;
extern crate chrono;
extern crate rand;

use chrono::prelude::*;
use rand::prelude::*;

use std::time::Duration;

const FIRE_VENDOR: u16 = 0x09e8;
const FIRE_PRODUCT: u16 = 0x0043;
const TO: Duration = Duration::from_millis(50);

const font: [[[bool; 4]; 4]; 10] = [
    [[false,false,true,false],
     [false,true,false,true],
     [false,true,false,true],
     [false,false,true,false]],
    [[false,false,false,true],
     [false,false,false,true],
     [false,false,false,true],
     [false,false,false,true]],
    [[false,true,true,false],
     [false,false,false,true],
     [false,true,true,false],
     [false,true,true,true]],
    [[false,true,true,true],
     [false,false,true,true],
     [false,false,false,true],
     [false,true,true,true]],
    [[false,true,false,true],
     [false,true,false,true],
     [false,false,true,true],
     [false,false,false,true]],
    [[false,true,true,true],
     [false,true,false,false],
     [false,false,true,true],
     [false,true,true,true]],
    [[false,true,true,true],
     [false,true,false,false],
     [false,true,true,true],
     [false,true,true,true]],
    [[false,true,true,true],
     [false,false,false,true],
     [false,false,true,false],
     [false,true,false,false]],
    [[false,true,true,false],
     [false,true,true,false],
     [false,false,true,true],
     [false,false,true,true]],
    [[false,true,true,true],
     [false,true,true,true],
     [false,false,false,true],
     [false,true,true,true]],
];

fn main() {
    let cont = libusb::Context::new().expect("Failed to initialize a libusb context");
    let devs = cont.devices().expect("Failed to get connected devices");
    
    let dev = devs.iter().find(|d| {
        if let Ok(desc) = d.device_descriptor() {
            if desc.vendor_id() == FIRE_VENDOR && desc.product_id() == FIRE_PRODUCT {
                true
            } else {
                false
            }
        } else {
            false
        }
    }).expect("Failed to find the FIRE");

    let cont = libusb::Context::new().expect("Failed to initialize a libusb context");
    let fires = flfire::get_fires(&cont);
    let mut handles = flfire::claim_fires(&fires[0..1]);
    let handle = &mut handles[0];
    
    // Clear all LEDS
    handle.write_bulk(1, &[0x0b,0xb0,0x7f,0], TO).unwrap();

    loop {
        let color = [
            (random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10),
            (random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10),
            (random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10),
        (random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10, random::<u8>() % 0x60 + 0x10),
        ];
        
        let time = Local::now();
        for x in 0..16usize {
            for y in 0..4usize {
                let active = match x / 4 {
                    xl if xl == 0 => font[(time.hour() / 10) as usize][y][x % 4],
                    xl if xl == 1 => font[(time.hour() % 10) as usize][y][x % 4],
                    xl if xl == 2 => font[(time.minute() / 10) as usize][y][x % 4],
                    xl if xl == 3 => font[(time.minute() % 10) as usize][y][x % 4],
                    xl => unreachable!(),
                };
                let (r,g,b) = if active { color[x / 4] } else { (0,0,0) };
                
                let pad_buf: [u8; 16] = [
                    0x04, 0xf0, 0x47, 0x7f,
                    0x04, 0x43, 0x65, 0x00,
                    0x04, 0x04, (y * 16 + x) as u8, r,
                    0x07, g, b, 0xf7
                ];
                handle.write_bulk(1, &pad_buf, TO).unwrap();
            }
        }
        
        std::thread::sleep_ms(1000);
    }
}
