extern crate flfire;
extern crate libusb;
extern crate rand;
use rand::prelude::*;

use std::time::Duration;
use std::cmp::min;

const FIRE_VENDOR: u16 = 0x09e8;
const FIRE_PRODUCT: u16 = 0x0043;
const TO: Duration = Duration::from_millis(50);

fn main() {
    let cont = libusb::Context::new().expect("Failed to initialize a libusb context");
    let fires = flfire::get_fires(&cont);
    let mut handles = flfire::claim_fires(&fires[0..1]);
    let handle = &mut handles[0];

    let (x_dim, y_dim, image) = flfire::read_pbm("/tmp/test.pbm");

    handle.write_bulk(1, &[0x0b,0xb0,0x7f,0], TO).unwrap();

    let clear_buf = [
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x00,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x01,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x02,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x03,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x04,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x05,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x06,0xf7,0x00,
        0x04,0xf0,0x47,0x7f,0x04,0x43,0x08,0x00,
        0x04,0x03,0x00,0x00,0x06,0x07,0xf7,0x00
    ];

    let mut width: u8 = 0x7f;
    let mut height: u8 = 0x1;
    let mut x: u8 = 0;
    let mut y: u8 = 0;

    loop {
        handle.write_bulk(1, &clear_buf, TO).unwrap();
        let vbuf = flfire::render_pixelbuf(&image, x_dim, y_dim, 0, 0);

        handle.write_bulk(1, &vbuf, TO).unwrap();

        break;
        let mut buf = [0u8; 5*4];
        handle.read_bulk(0x81, &mut buf, TO);
        // println!("{:x?}", &buf);

        for o in 0..5 {
            if buf[o*4] == 0x0b {
                match buf[o*4+2] {
                    0x10 => {
                        if buf[o*4+3] == 0x7f {
                            x = x.saturating_sub(1);
                        } else {
                            x = min(x + 1,0x7f);
                        }
                    },
                    0x11 => {
                        if buf[o*4+3] == 0x7f {
                            y = y.saturating_sub(1);
                        } else {
                            y = min(y + 1, 0x7);
                        }
                    },
                    0x12 => {
                        if buf[o*4+3] == 0x7f {
                            width = width.saturating_sub(1);
                        } else {
                            width = min(width + 1,0x7f);
                        }
                    },
                    0x13 => {
                        if buf[o*4+3] == 0x7f {
                            height = height.saturating_sub(1);
                        } else {
                            height = min(height + 1,7);
                        }
                    }
                    _ => {},
                }
            }
        }
    }
}
